function [tri, vert] = loadOff(path)
% From ShapeLAB

f = fopen(path, 'rt');
n = '';
while isempty(n)
    fgetl(f);
    n = sscanf(fgetl(f), '%d %d %d');
end
    
nv = n(1);
nt = n(2);
data = fscanf(f, '%f');

if(length(data) == nv*3 + nt*3)
    numsInTri = 3;
else 
    if(length(data) == nv*3 + nt*4)
        numsInTri = 4;
    else
        error('file format not supported');
    end
end

tri = reshape(data(end-numsInTri*nt+1:end), [4 nt])';
if(numsInTri ==4)
    tri = tri(:,2:4);
end
if(sum(tri(:) == 0) > 0)
    tri = tri + 1;
end

data = data(1:end-numsInTri*nt);

data = reshape(data, [length(data)/nv nv]);

vert = [data(1,:)' data(2,:)' data(3,:)'];

fclose(f);

end