clear,clc
%%
addpath('fastAuction_v2.5')
%% Loading shapes
X = loadshape_minimal('data/0001.isometry.1.off');
Y = loadshape_minimal('data/0001.isometry.2.off');

matches_gt = get_gt(X,Y);

%% Parameters

nsparse = 20; %number of sparse inputs
niters = 3; %number of iterations


varx = 2*X.area; % variance of Gaussian on source
vary = 2*Y.area; % variance of Gaussian on target



%% In this scenario we initialize with sparse gt-matches
%% Replace the following lines to use matching from your pipeline
xin = X.fps(1:nsparse);
yin = matches_gt(xin);

%%

for i=1:niters
    F = kernel_density_estimation(X,Y,xin,yin,varx,vary);
    xin = 1:X.n;
    yin = sparseAssignmentProblemAuctionAlgorithm(F,[],[],0);
    figure,vis_3D_correspondence(X,Y,yin);
    figure(444),plot_err_curve(xin,yin,matches_gt,Y.Gamma);hold on
end
%%